<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item label="部署名称" prop="sinsDeplName">
        <el-input v-model="queryParams.sinsDeplName" placeholder="请输入部署名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['sins:objsins:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['sins:objsins:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['sins:objsins:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['sins:objsins:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="sins-objsins-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="部署名称" align="center" prop="sinsDeplName" />
      <el-table-column label="方案范围" align="center" prop="sinsRange" />
      <el-table-column label="开始时间" align="center" prop="sinsStartTime" width="180" />
      <el-table-column label="完成时间" align="center" prop="sinsCompTime" width="180" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['sins:objsins:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['sins:objsins:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="700px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="部署名称" prop="sinsDeplName">
          <el-input v-model="form.sinsDeplName" placeholder="请输入部署名称" />
        </el-form-item>
        <el-form-item label="方案范围" prop="sinsRange">
          <el-input v-model="form.sinsRange" type="textarea" placeholder="请输入方案范围" />
        </el-form-item>
        <el-form-item label="所属单位" prop="orgGuid">
          <el-input v-model="form.orgGuid" placeholder="请输入所属单位" />
        </el-form-item>
        <el-form-item label="文件GUID" prop="pGuid">
          <el-input v-model="form.pGuid" placeholder="请输入文件GUID" />
        </el-form-item>
        <el-form-item label="发文单位GUID" prop="notIssuGuid">
          <el-input v-model="form.notIssuGuid" placeholder="请输入发文单位GUID" />
        </el-form-item>
        <el-form-item label="大坝 ID" prop="sinsLareId">
          <el-input v-model="form.sinsLareId" placeholder="请输入大坝 ID" />
        </el-form-item>
        <el-form-item label="通知时间" prop="sinsNotTime">
          <el-date-picker v-model="form.sinsNotTime" type="datetime" placeholder="选择通知时间" />
        </el-form-item>
        <el-form-item label="开始时间" prop="sinsStartTime">
          <el-date-picker v-model="form.sinsStartTime" type="datetime" placeholder="选择开始时间" />
        </el-form-item>
        <el-form-item label="完成时间" prop="sinsCompTime">
          <el-date-picker v-model="form.sinsCompTime" type="datetime" placeholder="选择完成时间" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SinsObjSins">
import { listObjSins, getObjSins, addObjSins, updateObjSins, delObjSins } from "@/api/slaj/sins";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const columns = ref({
  sinsDeplName: { label: "部署名称", visible: true },
  sinsRange: { label: "方案范围", visible: true },
  sinsStartTime: { label: "开始时间", visible: true },
  sinsCompTime: { label: "完成时间", visible: true }
});

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, sinsDeplName: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listObjSins(queryParams.value).then(response => {
    dataList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.guid);
  single.value = selection.length !== 1;
  multiple.value = !selection.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加安全检查方案";
}

function handleUpdate(row) {
  reset();
  getObjSins(row.guid || ids.value[0]).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改安全检查方案";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(valid => {
    if (valid) {
      if (form.value.guid != null) {
        updateObjSins(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addObjSins(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('是否确认删除？').then(function() {
    return delObjSins(row.guid || ids.value.join(","));
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/sins/objsins/export', { ...queryParams.value }, `安全检查方案_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { sinsDeplName: null, sinsRange: null, orgGuid: null, pGuid: null, notIssuGuid: null, sinsLareId: null, sinsNotTime: null, sinsStartTime: null, sinsCompTime: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
